专栏首页我爱编程Day13错误、调试和测试

Day13错误、调试和测试

错误处理

错误处理机制:try...except...finally...

try:
    print('try...')
    r = 10/5
    print('result:', int(r))
except ZeroDivisionError as e:
    print('except:', e)
finally:
    print('finally...')
print('END')

由于没有错误发生,所以except语句块不会被执行,但是finally如果有,则一定会被执行(可以没有finally语句)。

try...
result: 2
finally...
END

当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续代码不会继续执行,而是直接跳转至错误处理代码,即except语句块,执行完except后,如果有finally语句块,则执行finally语句块,至此,执行完毕。

try:
    print('try...')
    r = 10/0
    print('result:', int(r))
except ZeroDivisionError as e:
    print('except:', e)
finally:
    print('finally...')
print('END')
try...
except: division by zero
finally...
END

从输出可以看到,当错误发生时,后续语句print('result:', r)不会被执行,except由于捕获到ZeroDivisionError,因此被执行。最后,finally语句被执行。然后,程序继续按照流程往下走。 如果没有错误发生,可以在except语句块后面加一个else,当没有错误发生时,会自动执行else语句:

try:
    print('try...')
    r = 10 / int('2')
    print('result:', r)
except ValueError as e:
    print('ValueError:', e)
except ZeroDivisionError as e:
    print('ZeroDivisionError:', e)
else:
    print('no error!')
finally:
    print('finally...')
print('END')


try...
result: 5.0
no error!
finally...
END

Python的错误其实也是class,所有的错误类型都继承自BaseException,所以在使用except时需要注意的是,它不但捕获该类型的错误,还把其子类也“一网打尽”。比如:

try:
    foo()
except ValueError as e:
    print('ValueError')
except UnicodeError as e:
    print('UnicodeError')

第二个except永远也捕获不到UnicodeError,因为UnicodeErrorValueError的子类,如果有,也被第一个except给捕获了。

调用栈

def foo(s):
   return 10 / int(s)

def bar(s):
   return foo(s) * 2

def main():
   bar('0')
           
main()
ZeroDivisionError           Traceback (most recent call last)   #告诉我们这是错误的跟踪信息。
<ipython-input-18-beeefae3bbbc> in <module>()
      8     bar('0')
      9 
---> 10 main()    #调用main()出错了,在代码文件err.py的第10行代码,但原因是第8行:

<ipython-input-18-beeefae3bbbc> in main()
      6 
      7 def main():
----> 8     bar('0')   #调用bar('0')出错了,在代码文件err.py的第8行代码,但原因是第5行:
      9 
     10 main()

<ipython-input-18-beeefae3bbbc> in bar(s)
      3 
      4 def bar(s):
----> 5     return foo(s) * 2  #原因是return foo(s) * 2这个语句出错了,但这还不是最终原因,继续往下看:
      6 
      7 def main():

<ipython-input-18-beeefae3bbbc> in foo(s)
      1 def foo(s):
----> 2     return 10 / int(s)  #原因是return 10 / int(s)这个语句出错了,这是错误产生的源头,
      3 
      4 def bar(s):
      5     return foo(s) * 2
#  因为下面打印了:
ZeroDivisionError: division by zero
int('2.3')
Traceback (most recent call last):
  File "<pyshell#0>", line 1, in <module>
    int('2.3')

float('2.3')    #

mydict.py代码如下:

class Dict(dict):

    def __init__(self, **kw):
        super().__init__(**kw)

    def __getattr__(self, key):
        try:
            return self[key]
        except KeyError:
            raise AttributeError(r"'Dict' object has no attribute '%s'" % key)

    def __setattr__(self, key, value):
        self[key] = value

为了编写单元测试,我们需要引入Python自带的unittest模块,编写mydict_test.py如下:

import unittest

from mydict import Dict

class TestDict(unittest.TestCase):

    def test_init(self):
        d = Dict(a=1, b='test')
        self.assertEqual(d.a, 1)
        self.assertEqual(d.b, 'test')
        self.assertTrue(isinstance(d,dict))

    def test_key(self):
        d = Dict()
        d['key'] = 'value'
        self.assertEqual(d.key, 'value')

    def test_attr(self):
        d = Dict()
        d.key = 'value'
        self.assertTrue('key' in d)
        self.assertEqual(d['key'],'value')

    def test_keyerror(self):
        d = Dict()
        with self.assertRaises(KeyError):
            value = d['empty']

    def test_attrerror(self):
        d = Dict()
        with self.assertRaises(AttributeError):
            value = d.empty

编写单元测试时,我们需要编写一个测试类,从unittest.TestCase继承。 以test开头的方法就是测试方法,不以test开头的方法不被认为是测试方法,测试的时候不会被执行。

self.assertEqual(abs(-1), 1) # 断言函数返回的结果与1相等

运行单元测试

if __name__ == '__main__':
    unittest.main()
C:\Python36x32bit>python mydict_test.py
.....
----------------------------------------------------------------------
Ran 5 tests in 0.001s

OK

setUp与tearDown

可以在单元测试中编写两个特殊的setUp()tearDown()方法。这两个方法会分别在每调用一个测试方法的前后分别被执行。 setUp()tearDown()方法有什么用呢?设想你的测试需要启动一个数据库,这时,就可以在setUp()方法中连接数据库,在tearDown()方法中关闭数据库,这样,不必在每个测试方法中重复相同的代码:

class TestDict(unittest.TestCase):

    def setUp(self):
        print('setUp...')

    def tearDown(self):
        print('tearDown...')

每个测试方法调用前后会打印出setUp...tearDown...


pdb.set_trace() 调试

import pdb,然后,在可能出错的地方放一个pdb.set_trace(),就可以设置一个断点:

import pdb

s = '0'
n = int(s)
pdb.set_trace() # 运行到这里会自动暂停
print(10 / n)

运行代码,程序会自动在pdb.set_trace()暂停并进入pdb调试环境,可以用命令p查看变量,或者用命令c继续运行:

> c:\python36x32bit\practice.py(7)<module>()
-> print(10/n)
(Pdb) p n
0
(Pdb) c
Traceback (most recent call last):
  File "C:\Python36x32bit\practice.py", line 7, in <module>
    print(10/n)
ZeroDivisionError: division by zero

文档测试

Python内置的“文档测试”(doctest)模块可以直接提取注释中的代码并执行测试。 doctest严格按照Python交互式命令行的输入和输出来判断测试结果是否正确。只有测试异常的时候,可以用...表示中间一大段烦人的输出。

class Dict(dict):
    '''
    Simple dict but also support access as x.y style.

    >>> d1 = Dict()
    >>> d1['x'] = 100
    >>> d1.x
    100
    >>> d1.y = 200
    >>> d1['y']
    200
    >>> d2 = Dict(a=1, b=2, c='3')
    >>> d2.c
    '3'
    >>> d2['empty']
    Traceback (most recent call last):
        ...
    KeyError: 'empty'
    >>> d2.empty
    Traceback (most recent call last):
        ...
    AttributeError: 'Dict' object has no attribute 'empty'
    '''
    def __init__(self, **kw):
        super(Dict, self).__init__(**kw)

    def __getattr__(self, key):
        try:
            return self[key]
        except KeyError:
            raise AttributeError(r"'Dict' object has no attribute '%s'" % key)

    def __setattr__(self, key, value):
        self[key] = value

if __name__=='__main__':
    import doctest
    doctest.testmod()

什么输出也没有。这说明我们编写的doctest运行都是正确的。如果程序有问题就会报错。

本文参与腾讯云自媒体分享计划,欢迎正在阅读的你也加入,一起分享。

我来说两句

0 条评论
登录 后参与评论

相关文章

  • Day22psutil&图形界面

    psutil 用Python来编写脚本简化日常的运维工作是Python的一个重要用途。 在Python中获取系统信息的一个好办法是使用psutil这个第三方模...

    林清猫耳
  • Day18内建模块collections&base64collectionsbase64

    collections collections是Python内建的一个集合模块,提供了许多有用的集合类。 namedtuple >>> from collect...

    林清猫耳
  • Day20内建模块itertools&urllib

    itertools Python的内建模块itertools提供了非常有用的用于操作迭代对象的函数。 首先,我们看看itertools提供的几个“无限”迭代器...

    林清猫耳
  • 一日一技:在Python中,调用对象不存在的方法时自定义提示信息

    现在,我实例化这个类,并调用它的 play方法,由于这个方法不存在,所以现在必定导致报错,如下图所示。

    青南
  • [快学Python3]类基础

    概述 Python从设计之初就是面向对象的编程语言,所以在Python中创建一个类和对象是轻而易举的。 本文就Python的面向对象编程进行分享。 几个基本的概...

    苦叶子
  • Python小知识 | 这些技能你不会?(终章)

    写完今天这一篇,Python小知识这块就完了,一共四篇,也就是我过了一遍《零压力学Python》后记录下来的一些重要的点,希望对初学者或者复习Python基础的...

    小小詹同学
  • DeepFM算法解析及Python实现

    由于DeepFM算法有效的结合了因子分解机与神经网络在特征学习中的优点:同时提取到低阶组合特征与高阶组合特征,所以越来越被广泛使用。

    Bo_hemian
  • ZERO TO ONE,宜信支付系统架构总体剖析

    宜信支付系统每天平均处理订单量100w-200w笔,账单交易日交易量在300万笔以上、每个月处理支付交易流水在300亿左右、对接银行和三方有30多家以及接入商户...

    宜信技术学院
  • Python拉链法和开地址法实现字典

    Python字典(dictionary)是除列表之外python中最灵活的内置数据结构类型。列表是有序的对象结合,字典是无序的对象集合。两者之间的区别在于:字典...

    职场亮哥
  • Selenium2+python自动化48-登录方法(参数化)

    前言 登录这个场景在写用例的时候经常会有,我们可以把登录封装成一个方法,然后把账号和密码参数化,这样以后用的登录的时候,只需调用这个方法就行了 一、登录方法 1...

    上海-悠悠

扫码关注云+社区

领取腾讯云代金券